{*******************************************************************
*           Tabbed Webbrowser demo for Windows                     *
*             Based on IE / activexcontainer                       *
*                  Email: info@pilvet.fi                           *
*                                                                  *
*    Demo features:                                                *
*                                                                  *
*  - Creating tabbed browser                                       *
*  - Keyboard hook to capture key presses                          *
*  - Mouse hook to capture mouse events                            *
*  - Addressbar autocomplete (shlwapi)                             *
*  - Read/write typed urls to registry                             *
*  - Don't show Javascript errors                                  *
*  - Make tab key, F5, zooming work..                              *
*  - Run webbrowsercontrol in IE8/9/10 mode                        *
*  - Disable navigation sounds                                     *
*  - Disable activex / javascript / change other downloadoptions   *
*  - Disable scripts from specific domain/url(s)                   *
*  - Redirect xxx to yyy using Translateurl                        *
*  - Clear IE cache                                                *
*  - Using own useragent                                           *
*  - ...                                                           *
*                                                                  *
*  Note: 64bit Lazarus requires FPC 2.7.x compiler!                *
*                                                                  *
*******************************************************************}

unit Unit1;

{$mode Delphi}{$H+}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComObj, Menus, DateUtils, ComCtrls, Activex, ExtCtrls, Buttons,
  Variants, Registry, Math, FileUtil, ActivexContainer, SHDocVw_1_1_TLB, mshtml_4_0_TLB;

function SHAutoComplete(hwndEdit: HWND; dwFlags: DWORD): HRESULT; stdcall; external 'shlwapi.dll';

const
 CGID_DocHostCommandHandler: TGUID = (D1: $F38BC242; D2: $B950; D3: $11D1; D4: ($89, $18, $00, $C0, $4F, $C2, $C8, $36));
 CGID_WebBrowser: TGUID = '{ED016940-BD5B-11cf-BA4E-00C04FD70816}';
 OLECMDERR_E_NOTSUPPORTED = (-2147221248);
 INET_E_DEFAULT_ACTION = HResult($800C0011);
 URLPOLICY_DISALLOW = $03;
 DISPID_AMBIENT_USERAGENT = -5513;
 DISPID_AMBIENT_DLCONTROL = -5512;
 DLCTL_DLIMAGES = $00000010;
 DLCTL_VIDEOS = $00000020;
 DLCTL_BGSOUNDS = $00000040;
 DLCTL_NO_SCRIPTS = $00000080;
 DLCTL_NO_JAVA = $00000100;
 DLCTL_NO_RUNACTIVEXCTLS = $00000200;
 DLCTL_NO_DLACTIVEXCTLS = $00000400;
 DLCTL_NO_FRAMEDOWNLOAD = $00001000;
 DLCTL_PRAGMA_NO_CACHE = $00004000;
 SHACF_URLHISTORY = $00000002;
 SHACF_AUTOSUGGEST_FORCE_ON = $10000000;
 SHACF_AUTOAPPEND_FORCE_ON = $40000000;
 FEATURE_DISABLE_NAVIGATION_SOUNDS = 21;
 FEATURE_FROM_PROCESS = $00000002;
 FEATURE_TABBED_BROWSING = 19;
 WM_XBUTTONDOWN = $020B;
 DOCHOSTUIDBLCLK_DEFAULT = 0;
 DOCHOSTUIFLAG_ENABLE_FORMS_AUTOCOMPLETE = $4000;
 DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE = $0010;
 DOCHOSTUIFLAG_THEME = $40000;
 DOCHOSTUIFLAG_FLAT_SCROLLBAR = $80;
 OLECMDID_OLECMDID_OPTICAL_ZOOM = 63;
 OLECMDEXECOPT_OLECMDEXECOPT_DONTPROMPTUSER = 2;

type
  TPMsg = ^TMsg;

type
  POleCmd = ^TOleCmd;
  _tagOLECMD = record
    cmdID: Cardinal;
    cmdf: Longint;
  end;

  OLECMD = _tagOLECMD;
  TOleCmd = _tagOLECMD;
  POleCmdText = ^TOleCmdText;

  _tagOLECMDTEXT = record
    cmdtextf: Longint;
    cwActual: Cardinal;
    cwBuf: Cardinal;
    rgwz: array [0..0] of WideChar;
  end;

  OLECMDTEXT = _tagOLECMDTEXT;
  TOleCmdText = _tagOLECMDTEXT;
  IOleCommandTarget = interface(IUnknown) ['{b722bccb-4e68-101b-a2bc-00aa00404770}']
    function QueryStatus(CmdGroup: PGUID; cCmds: Cardinal; prgCmds: POleCmd; CmdText: POleCmdText): HResult; stdcall;
    function Exec(CmdGroup: PGUID; nCmdID, nCmdexecopt: DWORD; const vaIn: OleVariant; var vaOut: OleVariant): HResult; stdcall;
  end;

type
PInternetCacheEntryInfoA = ^INTERNET_CACHE_ENTRY_INFOA;
INTERNET_CACHE_ENTRY_INFOA = record
 dwStructSize: DWORD;
 lpszSourceUrlName: PAnsiChar;
 lpszLocalFileName: PAnsiChar;
 CacheEntryType: DWORD;
 dwUseCount: DWORD;
 dwHitRate: DWORD;
 dwSizeLow: DWORD;
 dwSizeHigh: DWORD;
 LastModifiedTime: TFileTime;
 ExpireTime: TFileTime;
 LastAccessTime: TFileTime;
 LastSyncTime: TFileTime;
 lpHeaderInfo: PBYTE;
 dwHeaderInfoSize: DWORD;
 lpszFileExtension: PAnsiChar;
 dwReserved: DWORD;
end;

PInternetCacheEntryInfo = PInternetCacheEntryInfoA;
TInternetCacheEntryInfoA = INTERNET_CACHE_ENTRY_INFOA;
TInternetCacheEntryInfo = TInternetCacheEntryInfoA;

function FindFirstUrlCacheEntryA(lpszUrlSearchPattern: PAnsiChar; var lpFirstCacheEntryInfo: TInternetCacheEntryInfo; var lpdwFirstCacheEntryInfoBufferSize: DWORD): THandle; stdcall; external 'wininet.dll';
function DeleteUrlCacheEntry(lpszUrlName: LPCSTR): BOOL; stdcall; external 'wininet.dll';
function FindNextUrlCacheEntryA(hEnumHandle: THandle; var lpNextCacheEntryInfo: TInternetCacheEntryInfo; var lpdwNextCacheEntryInfoBufferSize: DWORD): BOOL; stdcall; external 'wininet.dll';
function FindCloseUrlCache(hEnumHandle: THandle): BOOL; stdcall; external 'wininet.dll';

type
 PDocHostUIInfo = ^TDocHostUIInfo;
 TDocHostUIInfo = record
 cbSize: ULONG;
 dwFlags: DWORD;
 dwDoubleClick: DWORD;
end;

type
 IDocHostShowUI = interface(IUnknown) ['{c4d244b0-d43e-11cf-893b-00aa00bdce1a}']
 function ShowMessage(hwnd: THandle; lpstrText: POLESTR; lpstrCaption: POLESTR; dwType: longint;lpstrHelpFile: POLESTR;dwHelpContext: longint; var plResult: LRESULT): HRESULT; stdcall;
 function ShowHelp(hwnd: THandle; pszHelpFile: POLESTR; uCommand: integer; dwData: longint; ptMouse: TPoint; var pDispachObjectHit: IDispatch): HRESULT; stdcall;
end;

type //http://msdn.microsoft.com/en-us/library/aa753260%28v=vs.85%29.aspx
 IDocHostUIHandler = interface(IUnknown) ['{BD3F23C0-D43E-11CF-893B-00AA00BDCE1A}']
 function ShowContextMenu(const dwID: DWORD; const ppt: PPoint; const pcmdtReserved: IUnknown; const pdispReserved: IDispatch): HRESULT; stdcall;
 function GetHostInfo(var pInfo: TDocHostUIInfo): HRESULT; stdcall;
 function ShowUI(const dwID: DWORD; const pActiveObject: IOleInPlaceActiveObject; const pCommandTarget: IOleCommandTarget; const pFrame: IOleInPlaceFrame; const pDoc: IOleInPlaceUIWindow): HRESULT; stdcall;
 function HideUI: HRESULT; stdcall;
 function UpdateUI: HRESULT; stdcall;
 function EnableModeless(const fEnable: BOOL): HRESULT; stdcall;
 function OnDocWindowActivate(const fActivate: BOOL): HRESULT; stdcall;
 function OnFrameWindowActivate(const fActivate: BOOL): HRESULT; stdcall;
 function ResizeBorder(const prcBorder: PRect; const pUIWindow: IOleInPlaceUIWindow; const fRameWindow: BOOL): HRESULT; stdcall;
 function TranslateAccelerator(const lpMsg: PMSG; const pguidCmdGroup: PGUID; const nCmdID: DWORD): HRESULT; stdcall;
 function GetOptionKeyPath(var pchKey: POleStr; const dw: DWORD): HRESULT; stdcall;
 function GetDropTarget(const pDropTarget: IDropTarget; out ppDropTarget: IDropTarget): HRESULT; stdcall;
 function GetExternal(out ppDispatch: IDispatch): HRESULT; stdcall;
 function TranslateUrl(const dwTranslate: DWORD; const pchURLIn: POleStr; var ppchURLOut: POleStr): HRESULT; stdcall;
 function FilterDataObject(const pDO: IDataObject; out ppDORet: IDataObject): HRESULT; stdcall;
end;

type
  IInternetSecurityMgrSite = interface
    ['{79eac9ed-baf9-11ce-8c82-00aa004ba90b}']
    function GetWindow(out hwnd: HWnd): HRESULT; stdcall;
    function EnableModeless(fEnable: BOOL): HRESULT; stdcall;
  end;

type
  IInternetSecurityManager = interface
    ['{79eac9ee-baf9-11ce-8c82-00aa004ba90b}']
    function SetSecuritySite(Site: IInternetSecurityMgrSite): HRESULT; stdcall;
    function GetSecuritySite(out Site: IInternetSecurityMgrSite): HRESULT; stdcall;
    function MapUrlToZone(pwszUrl: LPCWSTR; out dwZone: DWORD; dwFlags: DWORD): HRESULT; stdcall;
    function GetSecurityId(pwszUrl: LPCWSTR; pbSecurityId: Pointer; var cbSecurityId: DWORD; dwReserved: DWORD): HRESULT; stdcall;
    function ProcessUrlAction(pwszUrl: LPCWSTR; dwAction: DWORD; pPolicy: Pointer; cbPolicy: DWORD; pContext: Pointer; cbContext: DWORD; dwFlags, dwReserved: DWORD): HRESULT; stdcall;
    function QueryCustomPolicy(pwszUrl: LPCWSTR; const guidKey: TGUID; out pPolicy: Pointer; out cbPolicy: DWORD; pContext: Pointer; cbContext: DWORD; dwReserved: DWORD): HRESULT; stdcall;
    function SetZoneMapping(dwZone: DWORD; lpszPattern: LPCWSTR; dwFlags: DWORD): HRESULT; stdcall;
    function GetZoneMappings(dwZone: DWORD; out enumString: IEnumString; dwFlags: DWORD): HRESULT; stdcall;
  end;

type
  PControlInfo = ^TControlInfo;
  tagCONTROLINFO = record
    cb: Longint;
    hAccel: HAccel;
    cAccel: Word;
    dwFlags: Longint;
  end;
  TControlInfo = tagCONTROLINFO;
  CONTROLINFO = TControlInfo;

type
  TDispID = Longint;

type
  IOleControl = interface
    ['{B196B288-BAB4-101A-B69C-00AA00341D07}']
    function GetControlInfo(var ci: TControlInfo): HRESULT; stdcall;
    function OnMnemonic(msg: PMsg): HRESULT; stdcall;
    function OnAmbientPropertyChange(dispid: TDispID): HRESULT; stdcall;
    function FreezeEvents(bFreeze: BOOL): HRESULT; stdcall;
  end;

type
  TLazBrowser = class(Activexcontainer.TActiveXContainer, IDispatch, IServiceProvider, IInternetSecurityManager, IDocHostUIHandler, IDocHostShowUI, IOleCommandTarget)
  protected
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer; Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HRESULT; stdcall;
    function QueryService(const rsid, iid: TGUID; out Obj): HRESULT; stdcall;
    function SetSecuritySite(Site: IInternetSecurityMgrSite): HRESULT; stdcall;
    function GetSecuritySite(out Site: IInternetSecurityMgrSite): HRESULT; stdcall;
    function MapUrlToZone(pwszUrl: LPCWSTR; out dwZone: DWORD; dwFlags: DWORD): HRESULT; stdcall;
    function GetSecurityId(pwszUrl: LPCWSTR; pbSecurityId: Pointer; var cbSecurityId: DWORD; dwReserved: DWORD): HRESULT; stdcall;
    function ProcessUrlAction(pwszUrl: LPCWSTR; dwAction: DWORD; pPolicy: Pointer; cbPolicy: DWORD; pContext: Pointer; cbContext: DWORD; dwFlags, dwReserved: DWORD): HRESULT; stdcall;
    function QueryCustomPolicy(pwszUrl: LPCWSTR; const guidKey: TGUID; out pPolicy: Pointer; out cbPolicy: DWORD; pContext: Pointer; cbContext: DWORD; dwReserved: DWORD): HRESULT; stdcall;
    function SetZoneMapping(dwZone: DWORD; lpszPattern: LPCWSTR; dwFlags: DWORD): HRESULT; stdcall;
    function GetZoneMappings(dwZone: DWORD; out enumString: IEnumString; dwFlags: DWORD): HRESULT; stdcall;
    function ShowContextMenu(const dwID: DWORD; const ppt: PPoint; const pcmdtReserved: IUnknown; const pdispReserved: IDispatch): HRESULT; stdcall;
    function GetHostInfo(var pInfo: TDocHostUIInfo): HRESULT; stdcall;
    function ShowUI(const dwID: DWORD; const pActiveObject: IOleInPlaceActiveObject;   const pCommandTarget: IOleCommandTarget; const pFrame: IOleInPlaceFrame; const pDoc: IOleInPlaceUIWindow): HRESULT; stdcall;
    function HideUI: HRESULT; stdcall;
    function UpdateUI: HRESULT; stdcall;
    function EnableModeless(const fEnable: BOOL): HRESULT; stdcall;
    function OnDocWindowActivate(const fActivate: BOOL): HRESULT; stdcall;
    function OnFrameWindowActivate(const fActivate: BOOL): HRESULT; stdcall;
    function ResizeBorder(const prcBorder: PRect; const pUIWindow: IOleInPlaceUIWindow; const fRameWindow: BOOL): HRESULT; stdcall;
    function TranslateAccelerator(const lpMsg: PMSG; const pguidCmdGroup: PGUID; const nCmdID: DWORD): HRESULT; stdcall;
    function GetOptionKeyPath(var pchKey: POleStr; const dw: DWORD): HRESULT; stdcall;
    function GetDropTarget(const pDropTarget: IDropTarget; out ppDropTarget: IDropTarget): HRESULT; stdcall;
    function GetExternal(out ppDispatch: IDispatch): HRESULT; stdcall;
    function TranslateUrl(const dwTranslate: DWORD; const pchURLIn: POleStr; var ppchURLOut: POleStr): HRESULT; stdcall;
    function FilterDataObject(const pDO: IDataObject; out ppDORet: IDataObject): HRESULT; stdcall;
    function IDocHostShowUI.ShowHelp = ShowUI_ShowHelp;
    function ShowUI_ShowHelp(HWND: THandle; pszHelpFile: POleStr; uCommand: Integer; dwData: Longint; ptMouse: TPoint; var pDispatchObjectHit: IDispatch): HRESULT; stdcall;
    function ShowMessage(HWND: THandle; lpstrText: POleStr; lpstrCaption: POleStr; dwType: Longint; lpstrHelpFile: POleStr; dwHelpContext: Longint; var plResult: LRESULT): HRESULT; stdcall;
    function IOleCommandTarget.QueryStatus = CommandTarget_QueryStatus;
    function CommandTarget_QueryStatus(CmdGroup: PGUID; cCmds: Cardinal; prgCmds: POleCmd; CmdText: POleCmdText): HRESULT; stdcall;
    function IOleCommandTarget.Exec = CommandTarget_Exec;
    function CommandTarget_Exec(CmdGroup: PGUID; nCmdID, nCmdexecopt: DWORD; const vaIn: OleVariant; var vaOut: OleVariant): HRESULT; stdcall;
  end;

type
  TCoInternetSetFeatureEnabled = function(aFeature: DWORD; dwFlags: DWORD; fEnable: BOOL): HRESULT; stdcall;

type

  { TForm1 }

  TForm1 = class(TForm)
    ax: TCheckBox;
    js: TCheckBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem48: TMenuItem;
    zpn: TMenuItem;
    zps: TMenuItem;
    zpp: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Status2: TPanel;
    PopupMenu1: TPopupMenu;
    Status1: TPanel;
    PageControl1: TPageControl;
    Timer1: TTimer;
    Timer2: TTimer;
    Browser_Back: TBitBtn;
    Browser_Forward: TBitBtn;
    Browser_Refresh: TBitBtn;
    Browser_Stop: TBitBtn;
    Browser_Home: TBitBtn;
    Ieaddress1: TComboBox;
    procedure dloptionsChange(Sender: TObject);
    procedure Ieaddress1DropDown(Sender: TObject);
    procedure Ieaddress1Select(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Ieaddress1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure PageControl1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure CreateNewTabBrowser(pindex: boolean);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure MenuItem10Click(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);
    function browser_wait(wb: TLazBrowser; wtime: dword): boolean;
    procedure closetab(Sender: TObject);
    procedure changetab(Sender: TObject);
    procedure Timer1timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure WBWindowClosing(ASender: TObject; IsChildWindow: WordBool; var Cancel: WordBool);
    procedure Open_new_tab(url: string);
    procedure update_dloption(WB: TLazBrowser);
    procedure update_agent(WB: TLazBrowser);
    procedure updatedloptions;
    procedure WBStatusTextChange(ASender: TObject; Text_: WideString);
    procedure WBNewWindow2(ASender: TObject; var ppDisp: IDispatch; var Cancel: WordBool);
    procedure WBBeforeNavigate2(ASender: TObject; pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData, Headers: OleVariant; var Cancel: WordBool);
    procedure WBDocumentComplete(ASender: TObject; pDisp: IDispatch; var URL: OleVariant);
    procedure Browser_Home_Click(Sender: TObject);
    procedure Browser_back_Click(Sender: TObject);
    procedure Browser_Forward_Click(Sender: TObject);
    procedure Browser_Stop_Click(Sender: TObject);
    procedure Browser_Refresh_Click(Sender: TObject);
    procedure closetabindex(index: integer);
    procedure zpnClick(Sender: TObject);
  private
    FStartTicks: int64;
    FStartDT: TDateTime;
    procedure SetStartDT(Value: TDateTime);
    property StartDT: TDateTime read FStartDT write SetStartDT;
    function GetDT: TDateTime;
  public
    handle_event: integer;
    zoompercent: array of integer;
  end;

const
  ab: string='about:blank';
  title1: string='Lazbrowser demo : Today is ';
  title2: string=' (System time)';
  homepage: string='http://lazarus.freepascal.org';

var
  Form1: TForm1;
  onull, nonav: OleVariant;
  KBHook, MHook: HHook;
  NewTab: TTabSheet;
  NewContainer: TLazBrowser;
  NewBrowser: TEvsWebBrowser;
  URLMonModule: THandle;
  CoInternetSetFeatureEnabledPtr: Pointer;
  ieversion, useragent: string;

implementation

{$R *.lfm}

{ TForm1 }

function TLazBrowser.CommandTarget_QueryStatus(CmdGroup: PGUID; cCmds: Cardinal; prgCmds: POleCmd; CmdText: POleCmdText): HRESULT;
begin
 prgCmds.cmdf:=OLECMDF_ENABLED;
 Result:=S_OK;
end;

//http://msdn.microsoft.com/en-us/library/windows/desktop/ms683797%28v=vs.85%29.aspx
function TLazBrowser.CommandTarget_Exec(CmdGroup: PGUID; nCmdID, nCmdexecopt: DWORD; const vaIn: OleVariant; var vaOut: OleVariant): HRESULT;
begin
 // Don't show script errors
 Result:=OLECMDERR_E_NOTSUPPORTED;
 if CmdGroup<>nil then
 begin
  if IsEqualGuid(cmdGroup^, CGID_DocHostCommandHandler) then
   if nCmdID = OLECMDID_SHOWSCRIPTERROR then
   begin
    Result:=S_OK;
    vaOut:=true;
    exit;
   end;
 end;
end;

function TLazBrowser.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer; Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HRESULT;
var setflags: integer;
begin
 if (Flags and DISPATCH_PROPERTYGET<>0) and (VarResult<>nil) then
 begin
  if DispID = DISPID_AMBIENT_DLCONTROL then
  begin
   setflags:=DLCTL_VIDEOS+DLCTL_BGSOUNDS+DLCTL_DLIMAGES;
   if (form1.ax.checked=false) then setflags:=setflags+DLCTL_NO_RUNACTIVEXCTLS+DLCTL_NO_DLACTIVEXCTLS;
   if (form1.js.checked=false) then setflags:=setflags+DLCTL_NO_SCRIPTS;
   PVariant(VarResult)^:=setflags;
   Result:=S_OK;
   exit;
  end;
  if (DispID = DISPID_AMBIENT_USERAGENT) and (useragent<>'') then
  begin
   POleVariant(VarResult)^:=useragent+#13#10;
   Result:=S_OK;
   exit;
  end;
 end;
 Result:=inherited invoke(dispid, iid, localeid, flags, params, varResult, ExcepInfo, ArgErr);
end;

function TLazBrowser.GetSecurityId(pwszUrl: LPCWSTR; pbSecurityId: Pointer; var cbSecurityId: DWORD; dwReserved: DWORD): HRESULT; stdcall;
begin
 Result:=INET_E_DEFAULT_ACTION;
end;

function TLazBrowser.GetSecuritySite(out Site: IInternetSecurityMgrSite): HRESULT; stdcall;
begin
 Result:=INET_E_DEFAULT_ACTION;
end;

function TLazBrowser.GetZoneMappings(dwZone: DWORD; out enumString: IEnumString; dwFlags: DWORD): HRESULT; stdcall;
begin
 Result:=INET_E_DEFAULT_ACTION;
end;

function TLazBrowser.MapUrlToZone(pwszUrl: LPCWSTR; out dwZone: DWORD; dwFlags: DWORD): HRESULT; stdcall;
begin
 Result:=INET_E_DEFAULT_ACTION;
end;

function TLazBrowser.ProcessUrlAction(pwszUrl: LPCWSTR; dwAction: DWORD; pPolicy: Pointer; cbPolicy: DWORD; pContext: Pointer; cbContext, dwFlags, dwReserved: DWORD): HRESULT; stdcall; var dwPolicy: DWORD;
begin
 // You can block scripts etc. from url "xxx.com" like this

 {if (ansipos('xxx.com', pwszurl)>0)
 begin
  dwPolicy:=URLPOLICY_DISALLOW;
  Dword(ppolicy^):=dwpolicy;
  Result:=S_OK;
  exit;
 end;}

 Result:=INET_E_DEFAULT_ACTION;
end;

function TLazBrowser.QueryCustomPolicy(pwszUrl: LPCWSTR; const guidKey: TGUID; out pPolicy: Pointer; out cbPolicy: DWORD; pContext: Pointer; cbContext, dwReserved: DWORD): HRESULT; stdcall;
begin
 Result:=INET_E_DEFAULT_ACTION;
end;

function TLazBrowser.SetSecuritySite(Site: IInternetSecurityMgrSite): HRESULT; stdcall;
begin
 Result:=INET_E_DEFAULT_ACTION;
end;

function TLazBrowser.SetZoneMapping(dwZone: DWORD; lpszPattern: LPCWSTR; dwFlags: DWORD): HRESULT; stdcall;
begin
 Result:=INET_E_DEFAULT_ACTION;
end;

function TLazBrowser.QueryService(const rsid, iid: TGUID; out Obj): HRESULT; stdcall;
begin
 if IsEqualGuid(IInternetSecurityManager, rsid) and IsEqualGuid(rsid, iid) then
  Result:=Queryinterface(IInternetSecurityManager, Obj)
 else
  Result:=E_NOINTERFACE;
end;

function TLazBrowser.ShowContextMenu(const dwID: DWORD; const ppt: PPoint; const pcmdtReserved: IUnknown; const pdispReserved: IDispatch): HRESULT; stdcall;
begin
 Result:=s_false;
end;

function TLazBrowser.GetHostInfo(var pInfo: TDocHostUIInfo): HRESULT; stdcall;
begin
 FillChar(pInfo, SizeOf(TDOCHOSTUIINFO), #0);
 pInfo.cbSize:=SizeOf(pInfo);
 pInfo.dwFlags:=DOCHOSTUIFLAG_ENABLE_FORMS_AUTOCOMPLETE+DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE+DOCHOSTUIFLAG_THEME+DOCHOSTUIFLAG_FLAT_SCROLLBAR;
 pInfo.dwDoubleClick:=DOCHOSTUIDBLCLK_DEFAULT;
 Result:=S_OK;
end;

function TLazBrowser.ShowUI(const dwID: DWORD; const pActiveObject: IOleInPlaceActiveObject; const pCommandTarget: IOleCommandTarget; const pFrame: IOleInPlaceFrame; const pDoc: IOleInPlaceUIWindow): HRESULT; stdcall;
begin
 Result:=S_FALSE;
end;

function TLazBrowser.HideUI: HRESULT; stdcall;
begin
 Result:=S_FALSE;
end;

function TLazBrowser.UpdateUI: HRESULT; stdcall;
begin
 Result:=S_FALSE;
end;

function TLazBrowser.EnableModeless(const fEnable: BOOL): HRESULT; stdcall;
begin
 Result:=S_OK;
end;

function TLazBrowser.OnDocWindowActivate(const fActivate: BOOL): HRESULT; stdcall;
begin
 Result:=S_OK;
end;

function TLazBrowser.OnFrameWindowActivate(const fActivate: BOOL): HRESULT; stdcall;
begin
 Result:=S_OK;
end;

function TLazBrowser.ResizeBorder(const prcBorder: PRect; const pUIWindow: IOleInPlaceUIWindow; const fRameWindow: BOOL): HRESULT; stdcall;
begin
 Result:=S_OK;
end;

function TLazBrowser.TranslateAccelerator(const lpMsg: PMSG; const pguidCmdGroup: PGUID; const nCmdID: DWORD): HRESULT; stdcall;
begin
 Result:=S_FALSE;
end;

function TLazBrowser.GetOptionKeyPath(var pchKey: POleStr; const dw: DWORD): HRESULT; stdcall;
begin
 pchKey:=nil;
 Result:=S_FALSE
end;

function TLazBrowser.GetDropTarget(const pDropTarget: IDropTarget; out ppDropTarget: IDropTarget): HRESULT; stdcall;
begin
 Result:=E_NOTIMPL;
end;

function TLazBrowser.GetExternal(out ppDispatch: IDispatch): HRESULT; stdcall;
begin
 ppDispatch:=nil;
 Result:=S_FALSE;
end;

function WideStringToLPOLESTR(const Src: WideString): POLEStr;
begin
 Result:=CoTaskMemAlloc((Length(Src)+1)*SizeOf(WideChar));
 if Result<>nil then
  Move(PWideChar(Src)^, Result^, (Length(Src)+1)*SizeOf(WideChar));
end;

function TLazBrowser.TranslateUrl(const dwTranslate: DWORD; const pchURLIn: POleStr; var ppchURLOut: POleStr): HRESULT; stdcall;
var s, s2, URLOut: widestring;
begin
 URLOut:='';

 // You can replace url xxx.com with yyy.com like this.
 // Using local variable is bad, use WideStringToLPOLESTR
 {s:=UTF8Encode(ansilowercase(pchURLIn));
 s2:='yyy.com';
 if (ansipos('xxx.com', s)>0) then URLOut:=s2;
 if URLOut<>'' then
 begin
  ppchURLOut:=WideStringToLPOLESTR(URLOut);
  Result:=S_OK;
  exit;
 end;}

 Result:=S_FALSE;
end;

function TLazBrowser.FilterDataObject(const pDO: IDataObject; out ppDORet: IDataObject): HRESULT; stdcall;
begin
 ppDORet:=nil;
 Result:=S_FALSE
end;

function TLazBrowser.ShowUI_ShowHelp(HWND: THandle; pszHelpFile: POleStr; uCommand: Integer; dwData: Longint; ptMouse: TPoint; var pDispatchObjectHit: IDispatch): HRESULT; stdcall;
begin
 Result:=S_OK;
end;

function TLazBrowser.ShowMessage(HWND: THandle; lpstrText: POleStr; lpstrCaption: POleStr; dwType: Longint; lpstrHelpFile: POleStr; dwHelpContext: Longint; var plResult: LResult): HRESULT; stdcall;
begin
 Result:=S_FALSE;
 if (dwtype=48) and (ansipos('activex', ansilowercase(lpstrtext))>0) then Result:=S_OK; //No activex dialog
end;

function CheckURLMonModule: Boolean;
begin
 if URLMonModule=0 then URLMonModule:=safeLoadLibrary('URLMON.DLL');
 Result:=URLMonModule>HINSTANCE_ERROR;
end;

function CheckURLMonModuleFunc(const Name: string; var ptr: Pointer): Boolean;
begin
 Result:=CheckURLMonModule;
 if Result then
 begin
  ptr:=GetProcAddress(URLMonModule, PChar(Name));
  Result:=Assigned(ptr);
  if not Result then ptr:=Pointer(1);
 end;
end;

function CoInternetSetFeatureEnabled(aFeature: DWORD; dwFlags: DWORD; fEnable: Boolean): HRESULT;
begin
 if (Integer(CoInternetSetFeatureEnabledPtr)>1) or
  CheckURLMonModuleFunc('CoInternetSetFeatureEnabled', CoInternetSetFeatureEnabledPtr) then
 Result:=TCoInternetSetFeatureEnabled(CoInternetSetFeatureEnabledPtr)(DWORD(aFeature), dwFlags, fEnable)
 else Result:=E_NOTIMPL;
end;

procedure TForm1.SetStartDT(Value: TDateTime);
begin
 FStartDT:=Value;
 FStartTicks:=GetTickCount;
end;

function TForm1.GetDT: TDateTime;
const RealMSec = 1/24/60/60/1000;
var ticks: int64;
begin
 ticks:=GetTickCount-FStartTicks;
 Result:=FStartDT+(ticks*RealMSec);
end;

function GetUserAgent(Browser: TEvsWebbrowser): String;
var ovDocument: OleVariant;
begin
 Result:='';
 if (Browser.comserver.Document = nil) then
  begin
   Browser.comserver.Navigate(OleVariant(ab), onull, onull, onull, onull);
  end;
  while (Browser.comserver.ReadyState<>READYSTATE_COMPLETE) do
  begin application.processmessages; sleep(10); end;
  try
   ovDocument:=Browser.comserver.Document;
   Result:=ovDocument.ParentWindow.navigator.userAgent;
  except; end;
end;

procedure TForm1.CreateNewTabBrowser(pindex: boolean);
var pc, p: integer;
begin
 NewTab:=TTabSheet.Create(PageControl1);
 with NewTab do
  begin
   Caption:='Opening..';
   PageControl:=PageControl1;
   Parent:=PageControl1;
   Visible:=true;
  end;
 NewContainer:=TLazBrowser.Create(NewTab);
 NewContainer.Parent:=NewTab;
 NewBrowser:=TEvsWebBrowser.Create(NewContainer);
 NewContainer.ComServer:=NewBrowser.ComServer;
 NewContainer.Align:=alClient;
 NewContainer.Active:=true;
 pc:=PageControl1.PageCount;
 setlength(zoompercent, pc);
 zoompercent[pc-1]:=100;
 with NewBrowser do
 begin
  Align:=alClient;
  Ondocumentcomplete:=WBDocumentComplete;
  Onbeforenavigate2:=WBBeforeNavigate2;
  Onwindowclosing:=WBWindowClosing;
  OnNewWindow2:=WBNewWindow2;
  OnStatustextChange:=WBStatusTextChange;
 end;
 if pindex=true then
 begin
  useragent:=GetUserAgent(NewBrowser);
  p:=ansipos(')', useragent);
  if p>0 then
  begin
   useragent:=stringreplace(useragent, ')', '; Lazbrowser)',[]);
   update_agent(NewContainer);
  end;
 end;
 PageControl1.ActivePage:=NewTab;
 if pindex=true then
 begin
  NewBrowser.comserver.navigate(OleVariant(homepage), onull, onull, onull, onull);
 end;
end;

procedure TForm1.MenuItem10Click(Sender: TObject);
var
  lpEntryInfo: PInternetCacheEntryInfo;
  hCacheDir, dwEntrySize: LongWord;
begin
  dwEntrySize:=0;
  FindFirstUrlCacheEntryA(nil, TInternetCacheEntryInfo(nil^), dwEntrySize);
  GetMem(lpEntryInfo, dwEntrySize);
  if dwEntrySize>0 then lpEntryInfo^.dwStructSize:=dwEntrySize;
  hCacheDir:=FindFirstUrlCacheEntryA(nil, lpEntryInfo^, dwEntrySize);
  if hCacheDir<>0 then
  begin
   repeat
    application.ProcessMessages;
    DeleteUrlCacheEntry(lpEntryInfo^.lpszSourceUrlName);
    FreeMem(lpEntryInfo, dwEntrySize);
    dwEntrySize:=0;
    FindNextUrlCacheEntryA(hCacheDir, TInternetCacheEntryInfo(nil^), dwEntrySize);
    GetMem(lpEntryInfo, dwEntrySize);
    if dwEntrySize>0 then lpEntryInfo^.dwStructSize:=dwEntrySize;
   until not FindNextUrlCacheEntryA(hCacheDir, lpEntryInfo^, dwEntrySize)
  end;
  FreeMem(lpEntryInfo, dwEntrySize);
  FindCloseUrlCache(hCacheDir);
  showmessage('Cache cleared..');
end;

procedure TForm1.WBStatusTextChange(ASender: TObject; Text_: WideString);
begin
 if TEvsWebBrowser(ASender).comserver<>TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver then exit;
 Status1.caption:=text_;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
var indeksi: integer;
begin
 indeksi:=PageControl1.ActivePageIndex;
 form1.open_new_tab(ab);
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
var vaIn, vaOut: OleVariant;
begin //Savedialog
 (TLazBrowser(PageControl1.ActivePage.Controls[0]).ComServer as IWebbrowser2).ExecWB(OLECMDID_SAVEAS, OLECMDEXECOPT_DODEFAULT, vaIn, vaOut);
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
 close;
end;

procedure Tform1.closetabindex(index: integer);
var i, p: integer;
    ap: boolean;
    startedtime: dword;
begin
 ap:=false;
 p:=0;
 if PageControl1.pages[index]=PageControl1.ActivePage then
 begin
  ap:=true;
  for i:=index-1 downto 0 do
   begin
    p:=i; // i is not defined after loop :)
    if PageControl1.pages[i].tabvisible=true then break;
   end;
  PageControl1.ActivePageIndex:=p;
 end;
 (TLazBrowser(PageControl1.pages[index].Controls[0]).comserver as IWebbrowser2).stop;
 (TLazBrowser(PageControl1.pages[index].Controls[0]).comserver as IWebbrowser2).navigate(OleVariant(ab), nonav, onull, onull, onull);
 startedtime:=gettickcount;
 while ((TLazBrowser(PageControl1.pages[index].Controls[0]).ComServer as IWebbrowser2).busy) or ((TLazBrowser(PageControl1.pages[index].Controls[0]).comserver as IWebbrowser2).readystate<>readystate_complete) do
 begin
  application.processmessages;
  sleep(10); if gettickcount>startedtime+3000 then break;
 end;
 TLazBrowser(PageControl1.pages[index].Controls[0]).active:=false;
 PageControl1.pages[index].tabvisible:=false;
 if ap=true then changetab(self);
end;

function Tform1.browser_wait(wb: TLazBrowser; wtime: Dword): boolean;
var startedtime: dword;
begin
 Result:=true;
 startedtime:=gettickcount;
 while ((wb.comserver as IWebbrowser2).busy) or ((wb.comserver as IWebbrowser2).readystate<>readystate_complete) do
  begin
   application.processmessages;
   sleep(10);
   if gettickcount>startedtime+wtime then
   begin
    Result:=false;
    exit;
   end;
  end;
end;

function DocumentLoaded(doc1: IDispatch): Boolean;
var iDoc: IHTMLDocument2;
begin
 if Assigned(doc1) then
 begin
  doc1.QueryInterface(IHTMLDocument2, iDoc);
  Result:=Assigned(iDoc);
 end;
end;

procedure SetFocusToDoc(WB: TLazBrowser);
var Obj: IOleObject;
begin
 if documentloaded((WB.comserver as IWebbrowser2).Document) then
 begin
  if (WB.comserver as IWebbrowser2).QueryInterface(IOleObject, Obj)=0 then
   Obj.DoVerb(OLEIVERB_UIACTIVATE, nil, WB, 0, WB.Handle, WB.ClientRect);
 end;
end;

procedure TForm1.closetab(Sender: TObject);
begin
 if PageControl1.tabindex<1 then exit;
 closetabindex(PageControl1.ActivePageIndex);
end;

procedure TForm1.changetab(Sender: TObject);
begin
 IEaddress1.Text:=(TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).locationurl;
 if DocumentLoaded((TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).document) then setfocustodoc(TLazBrowser(PageControl1.ActivePage.Controls[0]));
end;

procedure TForm1.Browser_Stop_Click(Sender: TObject);
begin
 (TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).Stop;
end;

procedure TForm1.Browser_Home_Click(Sender: TObject);
begin
 (TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).Navigate(OleVariant(UTF8Decode(homepage)), onull, onull, onull, onull);
end;

procedure TForm1.Browser_back_Click(Sender: TObject);
begin
 try (TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).GoBack; except; end;
end;

procedure TForm1.Browser_Forward_Click(Sender: TObject);
begin
 try (TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).GoForward; except; end;
end;

procedure TForm1.Browser_Refresh_Click(Sender: TObject);
begin
 (TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).Refresh;
end;

procedure TForm1.MenuItem11Click(Sender: TObject);
begin
 showmessage('Lazbrowser demo'#13#10#13#10'info@pilvet.fi');
end;

procedure TForm1.Timer1timer(Sender: TObject);
begin
 caption:=title1+FormatDateTime('dddd d.m. tt', getdt)+title2;
end;

procedure TForm1.WBWindowClosing(ASender: TObject; IsChildWindow: WordBool; var Cancel: WordBool);
begin
 cancel:=true;
end;

procedure Tform1.open_new_tab(url: string);
var i: integer;
begin
 for i:=1 to PageControl1.pagecount-1 do
  if (PageControl1.pages[i].tabvisible=false) then
   begin
    PageControl1.Pages[i].Caption:='Opening..';
    PageControl1.Pages[i].tabvisible:=true;
    TLazBrowser(PageControl1.Pages[i].controls[0]).active:=true;
    PageControl1.ActivePageIndex:=i;
    (TLazBrowser(PageControl1.Pages[i].Controls[0]).comserver as IWebbrowser2).navigate(OleVariant(UTF8Decode(url)), onull, onull, onull, onull);
    setfocustodoc(TLazBrowser(PageControl1.Pages[i].Controls[0]));
    exit;
   end;
 CreateNewTabBrowser(false);
 (TLazBrowser(PageControl1.pages[PageControl1.pagecount-1].Controls[0]).comserver as IWebbrowser2).navigate(OleVariant(UTF8Decode(url)), onull, onull, onull, onull);
 setfocustodoc(TLazBrowser(PageControl1.pages[PageControl1.pagecount-1].Controls[0]));
end;

procedure TForm1.WBNewWindow2(ASender: TObject; var ppDisp: IDispatch; var Cancel: WordBool);
var i, indeksi: integer;
begin
 indeksi:=PageControl1.ActivePageIndex;
 for i:=1 to PageControl1.pagecount-1 do
 if PageControl1.pages[i].tabvisible=false then
 begin
  PageControl1.pages[i].Caption:='Opening..';
  PageControl1.pages[i].tabvisible:=true;
  TLazBrowser(PageControl1.Pages[i].controls[0]).active:=true;
  PageControl1.activepageindex:=i;
  ppdisp:=(TLazBrowser(PageControl1.Pages[i].Controls[0]).comserver as IWebbrowser2).Application;
  exit;
 end;
 CreateNewTabBrowser(false);
 ppdisp:=(TLazBrowser(PageControl1.pages[PageControl1.pagecount-1].Controls[0]).comserver as IWebbrowser2).Application;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var i: integer;
begin
 UnHookWindowsHookEx(KBHook);
 UnHookWindowsHookEx(MHook);
 timer1.enabled:=false;
 PageControl1.ActivePageIndex:=0;
 for i:=PageControl1.pagecount-1 downto 0 do
  if form1.PageControl1.pages[i].tabVisible then
  begin
   (TLazBrowser(PageControl1.Pages[i].Controls[0]).comserver as IWebbrowser2).stop;
   (TLazBrowser(PageControl1.Pages[i].Controls[0]).comserver as IWebbrowser2).navigate(OleVariant(ab), onull, onull, onull, onull);
   browser_wait(TLazBrowser(PageControl1.Pages[i].Controls[0]), 2000);
  end;
 try
 if URLMonModule<>0 then FreeLibrary(URLMonModule);
 except end;
end;

procedure TForm1.Ieaddress1DropDown(Sender: TObject);
var
  Counter: Integer;
  S: wideString;
  GetTextTmp: PChar;
begin
 ieaddress1.items.clear;
 with TRegistry.Create do
 try
  RootKey:=HKEY_CURRENT_USER;
  if OpenKey('Software\Microsoft\Internet Explorer\TypedURLs', False) then
  begin
   for Counter:=1 to 25 do
   begin
    if ValueExists('Url'+IntToStr(Counter)) then
    begin
     S:=ReadString('Url'+IntToStr(Counter));
     GetTextTmp:=ieaddress1.Items.GetText;
     if (AnsiPos(S, GetTextTmp) = 0) and (Trim(S)<>'') then ieaddress1.items.Add(Trim(S));
     StrDispose(GetTextTmp);
    end;
   end;
   CloseKey;
  end;
 finally Free; end;
end;

procedure TForm1.Ieaddress1Select(Sender: TObject);
begin
 (TLazBrowser(PageControl1.activepage.controls[0]).comserver as IWebbrowser2).navigate(OleVariant(UTF8Decode(IEaddress1.Text)), onull, onull, onull, onull);
end;

procedure TForm1.dloptionsChange(Sender: TObject);
begin
 form1.updatedloptions;
end;

procedure Updatereg;
var
  MaxItems, Counter: Integer;
  Name: wideString;
  Reg: TRegistry;
begin
 Reg:=TRegistry.Create;
 try
 with Reg do
  begin
   RootKey:=HKEY_CURRENT_USER;
   if OpenKey('Software\Microsoft\Internet Explorer\TypedURLs', True) then
   begin
    Maxitems:=form1.Ieaddress1.items.Count;
    if MaxItems>25 then MaxItems:=25;
    for Counter:=0 to MaxItems-1 do
    begin
     Name:='Url'+IntToStr(Counter+1);
     if form1.Ieaddress1.items[Counter]<>'' then WriteString(Name, form1.Ieaddress1.items[Counter]);
    end;
   end;
   CloseKey;
  end;
  finally Reg.Free; end;
end;

procedure Updatereg2(remove: string);
var
  Counter: Integer;
  Name: wideString;
  Reg: TRegistry;
begin
 Reg:=TRegistry.Create;
 try
  with Reg do
   begin
    RootKey:=HKEY_CURRENT_USER;
    if OpenKey('Software\Microsoft\Internet Explorer\TypedURLs', False) then
    begin
    for counter:=0 to 24 do
     begin
      Name:='Url'+inttostr(counter+1);
      if ValueExists(Name) then if ReadString(name)=remove then deletevalue(name);
     end;
    end;
    CloseKey;
   end;
 finally Reg.Free; end;
end;

procedure TForm1.Ieaddress1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var text: string;
begin
 if key=vk_return then
 begin
  text:=IEaddress1.Text;
  (TLazBrowser(PageControl1.activepage.controls[0]).comserver as IWebbrowser2).navigate(OleVariant(UTF8Decode(text)), onull, onull, onull, onull);
  if ieaddress1.Items.Count<25 then
  begin
   if (ansipos(':', text)=0) and (ansipos('.', text)>0) then
   begin
    IEaddress1.Items.add(text);
    updatereg;
   end;
  end;
 end;
end;

procedure setzoompercent(WB: TLazBrowser; zoom: integer);
var vaIn, vaOut: OleVariant;
begin //zoompercent
 if documentloaded((WB.comserver as IWebbrowser2).document) then
 begin
  if (zoom<10) or (zoom>1000) then zoom:=100;
  vaIn:=zoom;
  (WB.ComServer as IWebbrowser2).ExecWB(OLECMDID_OLECMDID_OPTICAL_ZOOM, OLECMDEXECOPT_OLECMDEXECOPT_DONTPROMPTUSER, vaIn, vaOut);
  form1.zoompercent[WB.owner.ComponentIndex]:=zoom;
 end;
end;

procedure TForm1.zpnClick(Sender: TObject);
begin
 if zoompercent[TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).owner.componentindex]<1 then zoompercent[TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).owner.componentindex]:=100;
 if sender=zpn then setzoompercent(TLazBrowser(form1.PageControl1.ActivePage.Controls[0]), 100);
 if sender=zps then setzoompercent(TLazBrowser(form1.PageControl1.ActivePage.Controls[0]), zoompercent[TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).owner.componentindex]+10);
 if sender=zpp then setzoompercent(TLazBrowser(form1.PageControl1.ActivePage.Controls[0]), zoompercent[TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).owner.componentindex]-10);
end;

procedure TForm1.PageControl1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if button=mbmiddle then closetab(self);
end;

procedure TForm1.WBDocumentComplete(ASender: TObject; pDisp: IDispatch; var URL: OleVariant);
var r: integer;
 s: string;
 WB: TEvsWebBrowser;
begin
 WB:=TEvsWebBrowser(Asender);
 if (pDisp as IWebBrowser)<>WB.comserver then exit; // If not toplevel browser

 // Update tabs
 for r:=0 to PageControl1.pagecount-1 do
  if PageControl1.pages[r].tabvisible=true then
  begin
   try
   s:=UTF8Encode((TLazBrowser(PageControl1.Pages[r].Controls[0]).comserver as IWebbrowser2).locationName);
   except; end;
   if length(s)>27 then s:=copy(s,1,25)+'..';
   if (s='') or (ansipos(ab, ansilowercase(s))>0) then s:='Opening..';
   if s<>PageControl1.pages[r].caption then PageControl1.pages[r].caption:=s;
  end;

  // if activepage then update address and setfocus
  if WB.comserver=TLazBrowser(PageControl1.ActivePage.controls[0]).comserver then
  begin
   IEaddress1.Text:=UTF8Encode(WB.comserver.LocationURL);
   setfocustodoc(TLazBrowser(PageControl1.ActivePage.controls[0]));
  end;
end;

procedure TForm1.WBBeforeNavigate2(ASender: TObject; pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData, Headers: OleVariant; var Cancel: WordBool);
begin
 // If you need to cancel navigation to xxx
 {if ansipos('xxx', ansilowercase(URL))>0 then
 begin
  cancel:=true;
  exit;
 end; }

 // If activepage and toplevel browser then..
 if (TEvsWebbrowser(asender).comserver=TLazBrowser(PageControl1.ActivePage.Controls[0]).comserver) and (pDisp as IWebBrowser=(TEvsWebbrowser(Asender).owner as TLazBrowser).comserver) then
 begin
  IEaddress1.Text:=string(URL);
 end;
end;

function InvokeCMD(Document: IDispatch; InvokeIE: Boolean; Value1, Value2: Integer; var vaIn, vaOut: OleVariant): HRESULT;
var
  CmdTarget: IOleCommandTarget;
  PtrGUID: PGUID;
begin
  Result:=S_FALSE;
  if InvokeIE then
  begin
   New(PtrGUID);
   PtrGUID^:=CGID_WebBrowser;
  end
  else
   PtrGuid:=PGUID(nil);
  if DocumentLoaded(Document) then
  try
   Document.QueryInterface(IOleCommandTarget, CmdTarget);
   if CmdTarget <> nil then
   try
   Result:=CmdTarget.Exec(PtrGuid, Value1, Value2, vaIn, vaOut);
   finally
    CmdTarget._Release;
   end;
  except
  end;
 Dispose(PtrGUID);
end;

function Get_IE_Version: string;
var
  Reg: TRegistry;
  vr: string;
begin
  Result:='6';
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    Reg.OpenKeyreadonly(UTF8Decode('Software\Microsoft\Internet Explorer'));
    try
    Result:=copy(Reg.ReadString(UTF8Decode('Version')),1,1);
    except
     Result:='6';
    end;
    Reg.CloseKey;
    if Result='1' then Result:='10';
    if (Result='8') or (Result='9') or (Result='10') then
    begin
     try
      Reg.RootKey:=HKEY_CURRENT_USER;
      if Reg.OpenKey(UTF8Decode('Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION'), True) then
      begin
       vr:=ExtractFileName(Application.ExeName);
       if (Result='8') then Reg.WriteInteger(vr, 8000);
       if (Result='9') then Reg.WriteInteger(vr, 9000);
       if (Result='10') then Reg.WriteInteger(vr, 10000);
       Reg.CloseKey;
      end;
      except; end;
    end;
  finally
   Reg.Free;
  end;
end;

procedure TForm1.MenuItem7Click(Sender: TObject);
const HTMLID_FIND = 1;
var vaIn, vaOut: OleVariant;
begin //Find dialog
 InvokeCmd((TLazBrowser(PageControl1.ActivePage.Controls[0]).ComServer as IWebbrowser2).Document, true, HTMLID_FIND, 0, vaIn, vaOut);
end;

procedure TForm1.update_dloption(WB: TLazBrowser);
var Control: IOleControl;
begin
 if WB.comserver.QueryInterface(IOleControl, Control)=0 then Control.OnAmbientPropertyChange(DISPID_AMBIENT_DLCONTROL);
end;

procedure TForm1.update_agent(WB: TLazBrowser);
var Control: IOleControl;
begin
 if WB.comserver.QueryInterface(IOleControl, Control)=0 then Control.OnAmbientPropertyChange(DISPID_AMBIENT_USERAGENT);
end;

procedure TForm1.updatedloptions;
var i: integer;
begin
 for i:=0 to PageControl1.pagecount-1 do
  update_dloption(TLazBrowser(PageControl1.Pages[i].Controls[0]));
end;

procedure TForm1.MenuItem9Click(Sender: TObject);
const HTMLID_VIEWSOURCE = 2;
var vaIn, vaOut: OleVariant;
begin //Viewsource
 InvokeCmd((TLazBrowser(PageControl1.ActivePage.Controls[0]).ComServer as IWebbrowser2).Document, true, HTMLID_VIEWSOURCE, 0, vaIn, vaOut);
end;

// Handle events from keyboard and mouse hooks
procedure TForm1.Timer2Timer(Sender: TObject);
var event: integer;
begin
 if handle_event>0 then
 begin
  event:=handle_event;
  handle_event:=0; //reset
  if event=1 then MenuItem2Click(self); // New tab
  if event=2 then MenuItem3Click(self); // Save Page
  if event=3 then closetab(self); // Close tab
  if event=4 then MenuItem9Click(self); // View source
  if event=5 then setzoompercent(TLazBrowser(form1.PageControl1.ActivePage.Controls[0]), form1.zoompercent[TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).owner.componentindex]+10);
  if event=6 then setzoompercent(TLazBrowser(form1.PageControl1.ActivePage.Controls[0]), form1.zoompercent[TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).owner.componentindex]-10);
  if event=7 then MenuItem7Click(self); // Find..
  if event=8 then
  begin
   updatereg2(ieaddress1.Items[ieaddress1.itemindex]);
   ieaddress1.Items.Delete(ieaddress1.ItemIndex);
  end;
 end;
 if handle_event=0 then timer2.enabled:=false; // stop timer
end;

{ *** mouse and keyboard hooks ***
http://msdn.microsoft.com/en-us/library/windows/desktop/ms644984(v=vs.85).aspx
functions must return quickly. Work is done in timer2
}
function KeyboardHookProc(Code, wParam, lParam: LongInt): LongInt; stdcall;
 var
  Text: array[0..255] of char;
  msg: TMsg;
  IOIPAO: IOleInPlaceActiveObject;
  Dispatch: IDispatch;
begin
 if (Code<0) then
 begin
  Result:=CallNextHookEx(KBHook, Code, wParam, lParam);
  exit;
 end;

 // Exit if widow title is something else..
 GetWindowText(GetForegroundWindow, Text, 256);
 if pos(title1, Text)=0 then
 begin
  Result:=CallNextHookEx(KBHook, Code, wParam, lParam);
  exit;
 end;

 // tab key, F5 copy/cut/paste.. why this is required?
 if (wParam=VK_TAB) or
    (wParam=VK_F5) or
    ((GetKeyState(VK_CONTROL)<0) and (wParam = Ord('C'))) or
    ((GetKeyState(VK_CONTROL)<0) and (wParam = Ord('V'))) or
    ((GetKeyState(VK_CONTROL)<0) and (wParam = Ord('X'))) or
    ((GetKeyState(VK_CONTROL)<0) and (wParam = Ord('A'))) then
 begin
  Dispatch:=(TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).application;
  if (Dispatch<>nil) and (not (TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).Busy) then
  begin
   Dispatch.QueryInterface(IOleInPlaceActiveObject, IOIPAO);
   if IOIPAO<>nil then
   begin
    if (lParam shr 31)=0 then msg.message:=WM_KEYDOWN else msg.message:=WM_KEYUP;
    msg.wParam:=wParam;
    msg.lParam:=lParam;
    if IOIPAO.TranslateAccelerator(msg)=0 then begin Result:=1; IOIPAO:=nil; exit; end;
    IOIPAO:=nil;
   end;
  end;
 end;
 if (lParam shr 31)=0 then
 begin
  if wParam=VK_F3 then
  begin
   Result:=1; form1.handle_event:=7; form1.timer2.enabled:=true; exit; // Find..
  end;
  if wParam=VK_DELETE then
  begin
   if (form1.Ieaddress1.DroppedDown) and (form1.Ieaddress1.itemindex<>-1) then
   begin
    Result:=1; form1.handle_event:=8; form1.timer2.enabled:=true; exit; // Delete url
   end;
  end;
  if (GetKeyState(VK_CONTROL)<0) then
  begin
   if wParam = Ord('T') then
   begin
    Result:=1; form1.handle_event:=1; form1.timer2.enabled:=true; exit; // New tab
   end;
   if wParam = Ord('S') then
   begin
    Result:=1; form1.handle_event:=2; form1.timer2.enabled:=true; exit; // Save page
   end;
   if wParam = Ord('Q') then
   begin
    Result:=1; form1.handle_event:=3; form1.timer2.enabled:=true; exit; // Close tab
   end;
   if wParam = Ord('U') then
   begin
    Result:=1; form1.handle_event:=4; form1.timer2.enabled:=true; exit; // View source
   end;
   // Zoom percentage
   if (wParam=107) or (wParam=187) then
   begin
    Result:=1; form1.handle_event:=5; form1.timer2.enabled:=true; exit;
   end;
   if (wParam=109) or (wParam=189) then
   begin
    Result:=1; form1.handle_event:=6; form1.timer2.enabled:=true; exit;
   end;
  end;
 end;
 Result:=CallNextHookEx(KBHook, Code, wParam, lParam);
end;

function MouseHookProc(Code, wParam, lParam: LongInt): LongInt; stdcall;
var zp: Integer;
  MousePos: TPoint;
  Text: array[0..255] of char;
  HtmlElement: IHTMLElement;
  iHTMLDoc: IHtmlDocument2;
begin
 if (Code<0) then
 begin
  Result:=CallNextHookEx(MHook, Code, wParam, lParam);
  exit;
 end;

 // Exit if widow title is something else..
 GetWindowText(GetForegroundWindow, Text, 256);
 if pos(title1, Text)=0 then
 begin
  Result:=CallNextHookEx(MHook, Code, wParam, lParam);
  exit;
 end;

 // Element under mouse (Also when zoom <> 100)
 if wParam=WM_MOUSEMOVE then
 begin
  if Supports((TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).comserver as IWebbrowser2).Document, IHtmlDocument2, iHTMLDoc) then
   if GetCursorPos(MousePos) then
    begin
     MousePos:=TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).ScreenToClient(MousePos);
     if (mousepos.x>0) and (mousepos.y>0) and (mousepos.x+20<TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).width) and (mousepos.y<=TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).height) then
     begin
      zp:=form1.zoompercent[TLazBrowser(form1.PageControl1.ActivePage.Controls[0]).owner.componentindex];
      if zp<=0 then zp:=100;
      HtmlElement:=iHTMLDoc.ElementFromPoint(MousePos.X*100 div zp, MousePos.Y*100 div zp);
      if Assigned(HtmlElement) then
      begin
       form1.status2.caption:='Tag under mouse: '+UTF8Decode(htmlelement.tagname);
       //Result:=1;
       //exit;
      end;
     end;
    end;
 end;
 Result:=CallNextHookEx(MHook, Code, wParam, lParam);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Ieaddress1.DoubleBuffered:=true;
 SHAutoComplete(GetWindow(Ieaddress1.Handle, GW_CHILD), SHACF_URLHISTORY or SHACF_AUTOSUGGEST_FORCE_ON or SHACF_AUTOAPPEND_FORCE_ON);
 onull:=null;
 nonav:=2;
 MHook:=SetWindowsHookEx(WH_MOUSE, @MouseHookProc, HInstance, GetCurrentThreadId());
 KBHook:=SetWindowsHookEx(WH_KEYBOARD, @KeyboardHookProc, HInstance, GetCurrentThreadId());
end;

procedure TForm1.FormShow(Sender: TObject);
var Hour, Min, Sec, MSec: Word;
begin
 SetExceptionMask(GetExceptionMask+[exOverflow]+[exZeroDivide]+[exInvalidOp]); //set8087CW($133F);
 StartDT:=Now;
 LongDayNames[1]:='Sunday';
 LongDayNames[2]:='Monday';
 LongDayNames[3]:='Tuesday';
 LongDayNames[4]:='Wednesday';
 LongDayNames[5]:='Thursday';
 LongDayNames[6]:='Friday';
 LongDayNames[7]:='Saturday';
 DecodeTime(getdt, Hour, Min, Sec, MSec);
 ShortDateFormat:='d.m';
 Caption:=title1+FormatDateTime('dddd d.m. tt', getdt)+title2;
 CreateNewTabBrowser(true);
 IEaddress1.Text:=homepage;
 Timer1.Enabled:=true;
 if (ieversion='7') or (ieversion='8') or (ieversion='9') or (ieversion='10') then
 begin
  CoInternetSetFeatureEnabled(FEATURE_DISABLE_NAVIGATION_SOUNDS, FEATURE_FROM_PROCESS, True);
  CoInternetSetFeatureEnabled(FEATURE_TABBED_BROWSING, FEATURE_FROM_PROCESS, True);
 end;
end;

Initialization
 OleInitialize(nil);
 ieversion:=Get_IE_Version;

finalization
 OleUninitialize;

end.
